#ifndef _UTIL_H_
#define _UTIL_H_

#if (!defined(_WIN32_WCE))
	#define CreateFileForMapping CreateFile
#endif

#if (!defined(CSIDL_MYPICTURES))
	#define CSIDL_MYPICTURES 0x27
#endif

// Flag that the zip file has in addition to SFGAO_FOLDER in Windows XP and above
#if (!defined(SFGAO_STREAM))
	#define SFGAO_STREAM 0x00400000L
#endif

#if (!defined(BIF_NEWDIALOGSTYLE))
	#define BIF_NEWDIALOGSTYLE 0x0040
#endif

#if (!defined(BIF_USENEWUI))
	#define BIF_USENEWUI (BIF_NEWDIALOGSTYLE|BIF_EDITBOX)
#endif

#if (!defined(BCM_FIRST))
	#define BCM_FIRST 0x1600
#endif

#if (!defined(BCM_SETSHIELD))
	#define BCM_SETSHIELD (BCM_FIRST+0x000C)
#endif

#if (!defined(GWLP_ID))
	#define GWLP_ID GWL_ID
#endif

#if (!defined(GWLP_WNDPROC))
	#define GWLP_WNDPROC GWL_WNDPROC
#endif

#if (!defined(GWLP_USERDATA))
	#define GWLP_USERDATA GWL_USERDATA
#endif

#if (!defined(GCLP_HICONSM))
	#define GCLP_HICONSM GCL_HICONSM
#endif

#if (!defined(GCLP_HICON))
	#define GCLP_HICON GCL_HICON
#endif

#if (!defined(MAXINT_PTR))
	typedef int INT_PTR,*PINT_PTR;
#endif

#if (!defined(MAXUINT_PTR))
	typedef unsigned int UINT_PTR,*PUINT_PTR;
#endif

#if (!defined(MAXLONG_PTR))
	typedef long LONG_PTR,*PLONG_PTR;
#endif

#if (!defined(MAXULONG_PTR))
	typedef unsigned long ULONG_PTR,*PULONG_PTR;
	typedef ULONG_PTR DWORD_PTR,*PDWORD_PTR;
#endif

#if (!defined(SetWindowLongPtr))
	#define SetWindowLongPtr(hWnd,nIndex,dwNewLong) SetWindowLong(hWnd,nIndex,dwNewLong)
#endif

#if (!defined(GetWindowLongPtr))
	#define GetWindowLongPtr(hWnd,nIndex) GetWindowLong(hWnd,nIndex)
#endif

#if (!defined(SetClassLongPtr))
	#define SetClassLongPtr(hWnd,nIndex,dwNewLong) SetClassLong(hWnd,nIndex,dwNewLong)
#endif

#if (!defined(GetClassLongPtr))
	#define GetClassLongPtr(hWnd,nIndex) GetClassLong(hWnd,nIndex)
#endif

#if (!defined(Button_SetElevationRequiredState))
	#define Button_SetElevationRequiredState(hwnd,fRequired) (LRESULT)SendMessage((hwnd),BCM_SETSHIELD,0,(LPARAM)(fRequired))
#endif

#if (!defined(EnumDateFormats))
	#if (defined(UNICODE))
		#define EnumDateFormats EnumDateFormatsW
	#else
		#define EnumDateFormats EnumDateFormatsA
	#endif
#endif

#undef _ttoi
#define _ttoi(string) __ttoi(string)

#undef _tcsnicmp
#define _tcsnicmp(first,last,count) __tcsnicmp(first,last,count)

#undef _tcslwr
#define _tcslwr(string) __tcslwr(string)

#undef _tcsupr
#define _tcsupr(string) __tcsupr(string)

#undef __toupper
#define __toupper(ch) ((((ch)>='a')&&((ch)<='z'))?((ch)-('a'-'A')):(ch))

#define MSGBOX(s) MessageBox(NULL,s,NULL,MB_OK|MB_ICONINFORMATION)
#define MSGBOX_INT(s,d) do {TCHAR buffer[64];wsprintf(buffer,TEXT("[%s]\n%d"),s,d);MSGBOX(buffer);} while (0);

#define SORT_CALLBACK __cdecl
#if (defined(__WATCOMC__))
	#undef SORT_CALLBACK
	#define SORT_CALLBACK
#endif

#include <_WndProc.H>

#endif
